package application;

import java.io.InputStream;

import com.cloudrail.si.interfaces.CloudStorage;
import com.cloudrail.si.services.Box;
import com.cloudrail.si.services.Dropbox;
import com.cloudrail.si.services.GoogleDrive;
import com.cloudrail.si.services.OneDrive;

import application.model.JavaFXReceiver;
import javafx.application.Application;
import javafx.concurrent.Task;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.BorderPane;

public class Main extends Application {

	private final String REDIRECT_URL = "https://www.cloudrailauth.com/auth";
	private final String STATE = "randomString";

	@FXML
	public ImageView imageView;

	@Override
	public void start(Stage primaryStage) {
		try {
			FXMLLoader loader = new FXMLLoader();
			loader.setLocation(Main.class.getResource("view/MainView.fxml"));

			BorderPane root = new BorderPane();
			root.setCenter(loader.load());

			Scene scene = new Scene(root, 500, 300);
			scene.getStylesheets().add(getClass().getResource("application.css").toExternalForm());
			primaryStage.setScene(scene);
			primaryStage.show();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		launch(args);
	}

	@FXML
	public void onDropboxClicked() {
		CloudStorage service = new Dropbox(new JavaFXReceiver(), "u4gevj9clhvdjug", "9ol49hdlk8by9v9", REDIRECT_URL,
				STATE);
		downloadImage(service);
	}

	@FXML
	public void onGoogleDriveClicked() {
		CloudStorage service = new GoogleDrive(new JavaFXReceiver(),
				"638240013795-k6cavk4npp6gtqkpb56icpm0hm4uo6aq.apps.googleusercontent.com", "hhJG6zCn4F7ObJUzllL3BXoL",
				REDIRECT_URL, STATE);
		downloadImage(service);
	}

	@FXML
	public void onBoxClicked() {
		CloudStorage service = new Box(new JavaFXReceiver(), "zqgl7zrzxei2c076ss5k9hxf2ivbppfa",
				"ueG5uWHUarWYQNgldCsCwUwGzvSWlR0Y", REDIRECT_URL, STATE);
		downloadImage(service);
	}

	@FXML
	public void onOneDriveClicked() {
		CloudStorage service = new OneDrive(new JavaFXReceiver(), "000000004018F12F",
				"lGQPubehDO6eklir1GQmIuCPFfzwihMo", REDIRECT_URL, STATE);
		downloadImage(service);
	}

	private void downloadImage(CloudStorage service) {
		Task<Image> download = new Task<Image>() {
			
			@Override
			protected Image call() throws Exception {
				InputStream stream = service.download("/test.jpg");
				Image image = new Image(stream);
				return image;
			}
			
		};
		
		imageView.imageProperty().bind(download.valueProperty());
		new Thread(download).start();
	}
}
